//
// This code is part of http://gcbun.canadaeast.cloudapp.azure.com/pdf.
// Copyright (c) GrapeCity, Inc. All rights reserved.
//
using System;
using System.IO;
using System.Diagnostics;

namespace GcPdfSampleApp
{
    class Program
    {
        // This program creates an instance of the ProductListTemplate class and uses it to generate a PDF file.
        // The GrapeCity packages needed to build and run this sample are available on NuGet.org.
        static void Main(string[] args)
        {
            try
            {
                // gets the html template path
                string templatePath = File.ReadAllText(Path.Combine("Resources", "Misc", "ProductListTemplate.html"));
                
                // gets the output PDF report path
                string pdfPath = "ProductListTemplate.pdf";

                Console.WriteLine($"Press ENTER to create '{pdfPath}' in the current directory,\nor enter an alternative file name:");
                var t = Console.ReadLine();
                if (!string.IsNullOrWhiteSpace(t))
                    pdfPath = t;
                pdfPath = Path.GetFullPath(pdfPath);
                if (File.Exists(pdfPath))
                {
                    Console.WriteLine($"'{pdfPath}' exists.\nOVERWRITE (Y/n)?");
                    var yesno = Console.ReadLine();
                    if (yesno.ToLower() == "n")
                    {
                        Console.WriteLine("Aborted.");
                        return;
                    }
                }
                Console.WriteLine($"Generating '{pdfPath}'...");

                // binds the HTML template file with data and generates the PDF report
                var sample = new ProductListTemplate.ProductListTemplate();
                sample.CreatePDF(templatePath, pdfPath);
                Console.WriteLine("PDF generation successful!");

                // opens the generated PDF file
                ProcessStartInfo psi = new ProcessStartInfo() { FileName = pdfPath, UseShellExecute = true };
                Process.Start(psi);
            }
            catch (Exception ex)
            {
                Console.WriteLine($"Error: {ex.Message}");
            }
            finally
            {
                Console.WriteLine("Press any key to exit...");
                Console.ReadKey();
            }
        }
    }
}
